diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
index 66db64000..fccad9727 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.noise.ImprovedNoise;
 
@@ -11,7 +12,7 @@ public class WorldFeatureMudPatch extends WorldFeature
     private static final ImprovedNoise noise = new ImprovedNoise(new Random(0));
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z) {
+	public boolean place(World world, Random random, int x, int y, int z) {
         int chunkCoordX = world.getChunkFromBlockCoords(x, z).xPosition * 16;
         int chunkCoordZ = world.getChunkFromBlockCoords(x, z).zPosition * 16;
 
@@ -22,9 +23,9 @@ public class WorldFeatureMudPatch extends WorldFeature
                 float offset = (float) noise.getValue(chunkX / 30D, yPos / 30D, chunkZ / 30D) * 0.75f;
                 if(offset >= 0.125F) {
                     for(int i = 0; i < 5; i++) {
-                        if (world.getBlockId(chunkX, yPos - i, chunkZ) == Block.grass.id ||
-                                world.getBlockId(chunkX, yPos - i, chunkZ) == Block.dirt.id) {
-                            world.setBlock(chunkX, yPos - i, chunkZ, Block.mud.id);
+                        if (world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.GRASS.id ||
+                                world.getBlockId(chunkX, yPos - i, chunkZ) == Blocks.DIRT.id) {
+                            world.setBlock(chunkX, yPos - i, chunkZ, Blocks.MUD.id);
                         }
                     }
                 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index ca185c8d6..252887b3c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -18,34 +19,34 @@ public class WorldFeatureNetherLava extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Block.netherrack.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Block.netherrack.id)
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.NETHERRACK.id)
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Block.netherrack.id)
+        if(world.getBlockId(x - 1, y, z) == Blocks.NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Block.netherrack.id)
+        if(world.getBlockId(x + 1, y, z) == Blocks.NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Block.netherrack.id)
+        if(world.getBlockId(x, y, z - 1) == Blocks.NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Block.netherrack.id)
+        if(world.getBlockId(x, y, z + 1) == Blocks.NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y - 1, z) == Block.netherrack.id)
+        if(world.getBlockId(x, y - 1, z) == Blocks.NETHERRACK.id)
         {
             l++;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index 3326a24fe..dcd24662e 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
+import java.util.Map;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
@@ -11,18 +13,27 @@ import java.util.Random;
 
 public class WorldFeatureOre extends WorldFeature
 {
-    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "hasStoneStates"})
-    public WorldFeatureOre(int blockId, int numberOfBlocks, boolean hasStoneStates)
+    private int minableBlockId;
+    private int numberOfBlocks;
+    private final Map<Integer, Integer> variantMap;
+    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks"})
+    public WorldFeatureOre(int blockId, int numberOfBlocks)
     {
         minableBlockId = blockId;
         this.numberOfBlocks = numberOfBlocks;
-        this.hasStoneStates = hasStoneStates;
+        this.variantMap = null;
+    }
+    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "variantMap"})
+    public WorldFeatureOre(@NotNull Map<Integer, Integer> variantMap, int numberOfBlocks)
+    {
+        this.numberOfBlocks = numberOfBlocks;
+        this.variantMap = variantMap;
     }
 
     @Override
-	public boolean generate(World world, Random random, int xStart, int yStart, int zStart)
+	public boolean place(World world, Random random, int xStart, int yStart, int zStart)
     {
-        float f = random.nextFloat() * 3.141593F;
+        float f = random.nextFloat() * MathHelper.PI;
         double xMax = (float)(xStart + 8) + (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double xMin = (float)(xStart + 8) - (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
         double zMax = (float)(zStart + 8) + (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
@@ -35,14 +46,14 @@ public class WorldFeatureOre extends WorldFeature
             double d7 = yMax + ((yMin - yMax) * (double)l) / (double)numberOfBlocks;
             double d8 = zMax + ((zMin - zMax) * (double)l) / (double)numberOfBlocks;
             double d9 = (random.nextDouble() * (double)numberOfBlocks) / 16D;
-            double d10 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            double d11 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
-            int xVeinStart = MathHelper.floor_double(d6 - d10 / 2D);
-            int yVeinStart = MathHelper.floor_double(d7 - d11 / 2D);
-            int zVeinStart = MathHelper.floor_double(d8 - d10 / 2D);
-            int xVeinEnd = MathHelper.floor_double(d6 + d10 / 2D);
-            int yVeinEnd = MathHelper.floor_double(d7 + d11 / 2D);
-            int zVeinEnd = MathHelper.floor_double(d8 + d10 / 2D);
+            double d10 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int xVeinStart = MathHelper.floor(d6 - d10 / 2D);
+            int yVeinStart = MathHelper.floor(d7 - d11 / 2D);
+            int zVeinStart = MathHelper.floor(d8 - d10 / 2D);
+            int xVeinEnd = MathHelper.floor(d6 + d10 / 2D);
+            int yVeinEnd = MathHelper.floor(d7 + d11 / 2D);
+            int zVeinEnd = MathHelper.floor(d8 + d10 / 2D);
             for(int x = xVeinStart; x <= xVeinEnd; x++)
             {
                 double d12 = (((double)x + 0.5D) - d6) / (d10 / 2D);
@@ -62,23 +73,20 @@ public class WorldFeatureOre extends WorldFeature
                         double d14 = (((double)z + 0.5D) - d8) / (d10 / 2D);
                         if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
                         {
-                        	if (hasStoneStates)
+                        	if (variantMap != null)
                         	{
-                        		if(world.getBlockId(x, y, z) == Block.stone.id || world.getBlockId(x, y, z) == Block.netherrack.id)
-                        			world.setBlock(x, y, z, minableBlockId);
-                        		else if (world.getBlockId(x, y, z) == Block.basalt.id)
-                        			world.setBlock(x, y, z, minableBlockId + 1);
-                        		else if (world.getBlockId(x, y, z) == Block.limestone.id)
-                        			world.setBlock(x, y, z, minableBlockId + 2);
-                        		else if (world.getBlockId(x, y, z) == Block.granite.id)
-                        			world.setBlock(x, y, z, minableBlockId + 3);
+                                int blockId = world.getBlockId(x, y, z);
+                                if (blockId <= 0) continue;
+                                if (variantMap.containsKey(blockId)){
+                                    world.setBlock(x, y, z, variantMap.get(blockId));
+                                }
                         	}
                         	else
                         	{
                         		int id = world.getBlockId(x, y, z);
-                        		if (id == Block.stone.id || id == Block.netherrack.id ||
-                        				id == Block.basalt.id || id == Block.limestone.id ||
-                        				id == Block.granite.id)
+                        		if (id == Blocks.STONE.id || id == Blocks.NETHERRACK.id ||
+                        				id == Blocks.BASALT.id || id == Blocks.LIMESTONE.id ||
+                        				id == Blocks.GRANITE.id)
                         		{
                         			world.setBlock(x, y, z, minableBlockId);
                         		}
@@ -94,8 +102,4 @@ public class WorldFeatureOre extends WorldFeature
 
         return true;
     }
-
-    private int minableBlockId;
-    private int numberOfBlocks;
-    private boolean hasStoneStates = false;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java
new file mode 100644
index 000000000..2e7aa4355
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePermaice.java
@@ -0,0 +1,81 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeaturePermaice extends WorldFeature{
+    private int blockId;
+    private int numberOfBlocks;
+    private int generateInId;
+
+    @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
+    public WorldFeaturePermaice(int numberOfBlocks, Block block)
+    {
+        blockId = Blocks.PERMAICE.id;
+        this.numberOfBlocks = numberOfBlocks;
+        this.generateInId = block.id;
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z)
+    {
+        float f = random.nextFloat() * 3.141593F;
+        double d = (float)(x + 8) + (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
+        double d1 = (float)(x + 8) - (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
+        double d2 = (float)(z + 8) + (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
+        double d3 = (float)(z + 8) - (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
+        double d4 = y + random.nextInt(3) + 2;
+        double d5 = y + random.nextInt(3) + 2;
+        for(int l = 0; l <= numberOfBlocks; l++)
+        {
+            double d6 = d + ((d1 - d) * (double)l) / (double)numberOfBlocks;
+            double d7 = d4 + ((d5 - d4) * (double)l) / (double)numberOfBlocks;
+            double d8 = d2 + ((d3 - d2) * (double)l) / (double)numberOfBlocks;
+            double d9 = (random.nextDouble() * (double)numberOfBlocks) / 16D;
+            double d10 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin(((float)l * 3.141593F) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int i1 = MathHelper.floor(d6 - d10 / 2D);
+            int j1 = MathHelper.floor(d7 - d11 / 2D);
+            int k1 = MathHelper.floor(d8 - d10 / 2D);
+            int l1 = MathHelper.floor(d6 + d10 / 2D);
+            int i2 = MathHelper.floor(d7 + d11 / 2D);
+            int j2 = MathHelper.floor(d8 + d10 / 2D);
+            for(int k2 = i1; k2 <= l1; k2++)
+            {
+                double d12 = (((double)k2 + 0.5D) - d6) / (d10 / 2D);
+                if(d12 * d12 >= 1.0D)
+                {
+                    continue;
+                }
+                for(int l2 = j1; l2 <= i2; l2++)
+                {
+                    double d13 = (((double)l2 + 0.5D) - d7) / (d11 / 2D);
+                    if(d12 * d12 + d13 * d13 >= 1.0D)
+                    {
+                        continue;
+                    }
+                    for(int i3 = k1; i3 <= j2; i3++)
+                    {
+                        double d14 = (((double)i3 + 0.5D) - d8) / (d10 / 2D);
+                        if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
+                        {
+                            if(world.getBlockId(k2, l2, i3) == generateInId)
+                            {
+                                world.setBlock(k2, l2, i3, blockId);
+                            }
+                        }
+                    }
+
+                }
+
+            }
+
+        }
+
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
index 22e62ea82..b1b7ba0cc 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumpkin.java
@@ -1,12 +1,13 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldGenerator, World, Block, BlockGrass
+//            WorldGenerator, World, Block, GrassBlock
 
 public class WorldFeaturePumpkin extends WorldFeature
 {
@@ -16,18 +17,18 @@ public class WorldFeaturePumpkin extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 64; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Block.grass.id && Block.pumpkin.canPlaceBlockAt(world, i1, j1, k1))
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.GRASS.id && Blocks.PUMPKIN.canPlaceBlockAt(world, i1, j1, k1))
             {
                 if(random.nextInt(50)== 0)
-                    world.setBlockAndMetadata(i1, j1, k1, Block.pumpkinCarvedIdle.id, random.nextInt(4));
-                else    world.setBlockWithNotify(i1, j1, k1, Block.pumpkin.id);
+                    world.setBlockAndMetadata(i1, j1, k1, Blocks.PUMPKIN_CARVED_IDLE.id, random.nextInt(4));
+                else    world.setBlockWithNotify(i1, j1, k1, Blocks.PUMPKIN.id);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
index dcf3ff191..ace8cd0bd 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -17,15 +18,15 @@ public class WorldFeatureRichScorchedDirt extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
 
         for(int x1 = x - numberOfBlocks; x1 < x + numberOfBlocks; x1++ ) {
             for(int y1 = y - 2; y1 <= y+2; y1++ ) {
                 for(int z1 = z - numberOfBlocks; z1 < z + numberOfBlocks; z1++ ) {
                     if(random.nextInt(8) == 0){
-                        if(world.getBlockId(x1, y1, z1) == Block.dirtScorched.id)
-                            world.setBlock(x1, y1, z1, Block.dirtScorchedRich.id);
+                        if(world.getBlockId(x1, y1, z1) == Blocks.DIRT_SCORCHED.id)
+                            world.setBlock(x1, y1, z1, Blocks.DIRT_SCORCHED_RICH.id);
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
index e45060cd4..fdd84aa88 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
@@ -1,21 +1,22 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves,
-//            BlockFlower
+//            FlowerBlock
 
 public class WorldFeatureSpinifexPatch extends WorldFeature
 {
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z)
+    public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BaseLeavesBlock) && y > 0; y--) { }
         for(int i1 = 0; i1 < 64; i1++)
         {
             int j1 = (x + random.nextInt(4)) - random.nextInt(4);
@@ -24,9 +25,9 @@ public class WorldFeatureSpinifexPatch extends WorldFeature
 
             int meta = 0;
 
-            if(world.isAirBlock(j1, k1, l1) && Block.spinifex.canBlockStay(world, j1, k1, l1))
+            if(world.isAirBlock(j1, k1, l1) && Blocks.SPINIFEX.canBlockStay(world, j1, k1, l1))
             {
-                world.setBlockAndMetadata(j1, k1, l1, Block.spinifex.id, meta);
+                world.setBlockAndMetadata(j1, k1, l1, Blocks.SPINIFEX.id, meta);
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
index 131380158..a01737acc 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSponge.java
@@ -1,33 +1,34 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldGenerator, World, Block, BlockFlower
+//            WorldGenerator, World, Block, FlowerBlock
 
 public class WorldFeatureSponge extends WorldFeature
 {
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if (world.getBlockId(x, y - 1, z) != Block.fluidWaterStill.id)
+        if (world.getBlockId(x, y - 1, z) != Blocks.FLUID_WATER_STILL.id)
             return false;
         for(int l = 0; l < 16; l++) {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
 
-            for (; world.getBlockId(i1, y - 1, k1) == Block.fluidWaterStill.id; y--);
+            for (; world.getBlockId(i1, y - 1, k1) == Blocks.FLUID_WATER_STILL.id; y--);
 
-            if(world.getBlockId(i1, y-1, k1) != Block.sand.id && world.getBlockId(i1, y-1, k1) != Block.dirt.id)
+            if(world.getBlockId(i1, y-1, k1) != Blocks.SAND.id && world.getBlockId(i1, y-1, k1) != Blocks.DIRT.id)
                 continue;
             if(world.getBlockId(i1, y+1, k1) == 0)
                 continue;
 
-            world.setBlockRaw(i1, y, k1, Block.spongeWet.id);
+            world.setBlockRaw(i1, y, k1, Blocks.SPONGE_WET.id);
         }
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
index 3e754dd60..e83fd6c4b 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCane.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
@@ -17,7 +18,7 @@ public class WorldFeatureSugarCane extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 20; l++)
         {
@@ -31,9 +32,9 @@ public class WorldFeatureSugarCane extends WorldFeature
             int l1 = 2 + random.nextInt(random.nextInt(3) + 1);
             for(int i2 = 0; i2 < l1; i2++)
             {
-                if(Block.sugarcane.canBlockStay(world, i1, j1 + i2, k1))
+                if(Blocks.SUGARCANE.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Block.sugarcane.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id);
                 }
             }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
index a7e97ebc5..316506f46 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSugarCaneTall.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
@@ -17,7 +18,7 @@ public class WorldFeatureSugarCaneTall extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         for(int l = 0; l < 20; l++)
         {
@@ -31,9 +32,9 @@ public class WorldFeatureSugarCaneTall extends WorldFeature
             int l1 = 5 + random.nextInt(random.nextInt(10) + 1);
             for(int i2 = 0; i2 < l1; i2++)
             {
-                if(Block.sugarcane.canBlockStay(world, i1, j1 + i2, k1))
+                if(Blocks.SUGARCANE.canBlockStay(world, i1, j1 + i2, k1))
                 {
-                    world.setBlock(i1, j1 + i2, k1, Block.sugarcane.id);
+                    world.setBlock(i1, j1 + i2, k1, Blocks.SUGARCANE.id);
                 }
             }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
index ec473a14a..2d517af7d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, BlockLeaves, 
-//            BlockFlower
+//            FlowerBlock
 
 public class WorldFeatureTallGrass extends WorldFeature
 {
@@ -20,10 +20,10 @@ public class WorldFeatureTallGrass extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int l;
-        while (((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0) {
+        while (((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BaseLeavesBlock) && y > 0) {
             y--;
         }
         for(int i1 = 0; i1 < 128; i1++)
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
index 5836b8c06..b0d23c6a8 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -23,7 +24,7 @@ public class WorldFeatureTree extends WorldFeature
     }
 
     @Override
-	public boolean generate(World world, Random random, int x, int y, int z)
+	public boolean place(World world, Random random, int x, int y, int z)
     {
         int treeHeight = random.nextInt(3) + heightMod;
         boolean canSpawn = true;
@@ -112,11 +113,11 @@ public class WorldFeatureTree extends WorldFeature
     
     public static Block getDirtForGrass(int id) {
     	// TODO make this not hardcoded
-    	if(id == Block.grass.id || id == Block.grassRetro.id) {
-    		return Block.dirt;
+    	if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id) {
+    		return Blocks.DIRT;
     	}
-    	if(id == Block.grassScorched.id) {
-    		return Block.dirtScorched;
+    	if(id == Blocks.GRASS_SCORCHED.id) {
+    		return Blocks.DIRT_SCORCHED;
     	}
     	return null;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
index 29388dc5e..8504417f2 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -64,15 +65,15 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
         for(int i = 0; i != dimensions[dim0] + delta; i += delta)
         {
             int[] pos = { 0, 0, 0 };
-            pos[dim0] = MathHelper.floor_double((double)startPos[dim0] + (double)i + 0.5D);
-            pos[dim1] = MathHelper.floor_double((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
-            pos[dim2] = MathHelper.floor_double((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
+            pos[dim0] = MathHelper.floor((double)startPos[dim0] + (double)i + 0.5D);
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
             world.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
         }
     }
 
     @Override
-    public boolean generate(World world, Random random, int x, int y, int z)
+    public boolean place(World world, Random random, int x, int y, int z)
     {
         int l = random.nextInt(3) + heightMod;
         int noCanopies = 2;
@@ -181,11 +182,11 @@ public class WorldFeatureTreeCaatinga extends WorldFeature
 
     public static Block getDirtForGrass(int id) {
         // TODO make this not hardcoded
-        if(id == Block.grass.id || id == Block.grassRetro.id) {
-            return Block.dirt;
+        if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id) {
+            return Blocks.DIRT;
         }
-        if(id == Block.grassScorched.id) {
-            return Block.dirtScorched;
+        if(id == Blocks.GRASS_SCORCHED.id) {
+            return Blocks.DIRT_SCORCHED;
         }
         return null;
     }
